﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Timer1Q As Timer
	Dim TimerContagemRegressivaQ As Timer
	Dim sYQ As Long
	Dim sXQ As Long
	Dim MPFundoQuebraCabeca,MPEncaixe As MediaPlayer
	Dim mapQuebraCabecas As Map
	Dim mapEsboco As Map
	Dim imgNivel As Bitmap
	Dim imgFundoQuebraCabeca,imgBtnPainelNivel As Bitmap
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim NbOfTiles, NbCols, NbLigs As Int
	NbOfTiles = NbCols * NbLigs
	Dim Tiles(NbOfTiles) As ClsFloatingWindow
	Dim janela As ClsFloatingWindow
	Dim bd(NbOfTiles) As BitmapDrawable
	Dim Anim(NbOfTiles) As AnimationPlus
	Dim ivEdges As ImageView
	Dim cvEdges As Canvas
	Dim BP As BitmapPlus
	Dim TimeBeforeScattering As Int
	TimeBeforeScattering = 2000
	Dim EnlargeFactor As Float
	EnlargeFactor = 1.1
	Dim AnimBtn As AnimationPlus
	Dim menu As menuMod
	Dim aimacaoSucessoResposta As AnimationPlus
	Dim painelModal As Panel
	Private imgSucesso As ImageView
	Dim MpSomConclusaoMontagem As MediaPlayer
	Dim contador As Int = 3
	Dim lblContador As Label
	Dim TimeFont As Typeface
	Dim arrayImagens(12) As String
	Dim imagemAnterior As String 
	Private imgMenu As ImageView
	Private imgNivelFacil As ImageView
	Private imgNivelMedio As ImageView
	Dim AnimSet As AnimationSet
	Dim AnimacaoCliqueBotaoNivel As AnimationPlus
	Dim MPEfeitosSonoros As MediaPlayer
	Dim nivelSelecionado As String 
	Private lblSelNivel As Label
	Dim AndroidResources1 As AndroidResources
	Private lblTituloPersonagem As Label
	Dim imgVwEsbocoQuebraCabeca As BetterImageView
	Private imgVoltar As ImageView
	Private painelFundoSelNivel As Panel
	Dim primeiroAcesso As Boolean
	Dim bannerInterAdmob As bannerAdmobInterModule
End Sub

Sub Activity_Create(FirstTime As Boolean)
	primeiroAcesso = FirstTime
	sYQ = baseMod.alturaTela
	sXQ = baseMod.larguraTela
	montaLayout
End Sub

Sub montaLayout
	Activity.Tag = "frmquebraCabeca"
	Activity.LoadLayout("vwQuebraCabecas")
	bannerInterAdmob.Initialize
	
	ivEdges.Initialize("")
	Activity.Color = Colors.RGB(255,155,12)
	Activity.AddView(ivEdges, 26%x, 15%y, 60%x, 90%y)
	
	Timer1Q.Interval = TimeBeforeScattering
		
	setarStatusSomFundo
	
	'IMAGEM PUZZLE # PORTUGUES # INGLES
	arrayImagens(0) = "puzzleCavalo.png#Cavalo#Horse#cavalo.mp3"
	arrayImagens(1) = "puzzlePeru.png#Peru#Turkey#peru.mp3"
	arrayImagens(2) = "puzzleGolfinho.png#Golfinho#Dolphin"
	arrayImagens(3) = "puzzleTartaruga.png#Tartaruga#Sea Turtle"
	arrayImagens(4) = "puzzlePato.png#Pato#Duck#pato.mp3"
	arrayImagens(5) = "puzzleBaleia.png#Baleia#Whale"
	arrayImagens(6) = "puzzleBode.png#Bode#Billy-Goat#cabra.mp3"
	arrayImagens(7) = "puzzleGaloGalinha.png#Galo e Galinha#Cock and Chicken#galo.mp3"
	arrayImagens(8) = "puzzleVaca.png#Vaca#Cow#vaca.mp3"
	arrayImagens(9) = "puzzleArraia.png#Arraia#Ray Fish"
	arrayImagens(10) = "puzzlePeixe.png#Peixe#Fish"
	arrayImagens(11) = "puzzlePorco.png#Porco#Pig#porco.mp3"
	
	TimeFont = Typeface.LoadFromAssets("HVD_Bodedo.ttf")
	
	If primeiroAcesso = True Then
	
	'Música de Fundo e de Encaixe
	Try
		If baseMod.indMusicaFundoHabilitado = True Then
			MPFundoQuebraCabeca.Initialize2("MPFundoQuebraCabeca")
			MPFundoQuebraCabeca.SetVolume(1,1)
			MPFundoQuebraCabeca.Load(File.DirAssets, "musicaFundoQuebraCabeca.mp3") 'Music not music.
			MPFundoQuebraCabeca.Looping = True
			MPFundoQuebraCabeca.Play
		End If
		
		MPEncaixe.Initialize2("MPEncaixe")
		MPEncaixe.SetVolume(1,1)
		MPEncaixe.Load(File.DirAssets, "encaixePeca.mp3") 'Music not music.
		MPEncaixe.Looping = False
	Catch
     
  	End Try
	
		mapQuebraCabecas.Initialize
		mapEsboco.Initialize
	
		imgFundoQuebraCabeca.Initialize3(LoadBitmapSample(File.DirAssets, "telaQuebraCabeca.jpg",baseMod.larguraTela,baseMod.alturaTela))
		imgBtnPainelNivel.Initialize3(LoadBitmapSample(File.DirAssets, "bgSelecionaNivel.png",baseMod.larguraTela,baseMod.alturaTela))
		
	End If
	
	Dim btm As BitmapDrawable
	btm.Initialize(imgFundoQuebraCabeca)
	btm.Gravity = Gravity.FILL
	Activity.Background = btm
	
	Dim btmPainelNivel As BitmapDrawable
	btmPainelNivel.Initialize(imgBtnPainelNivel)
	btmPainelNivel.Gravity = Gravity.FILL
	painelFundoSelNivel.Background = btmPainelNivel
	
	lblContador.Typeface = TimeFont
	lblSelNivel.Typeface = TimeFont
	lblTituloPersonagem.Typeface = TimeFont
	lblSelNivel.TextColor = Colors.White
	lblContador.BringToFront
	
	baseMod.SetObjLayOut(lblTituloPersonagem, 0 , 0 , 320dip, 50dip,sXQ,sYQ)
	lblTituloPersonagem.TextSize = baseMod.ScaleToSize(28,True,sXQ,sYQ)
	
	lblTituloPersonagem.Left = ((baseMod.larguraTela - lblTituloPersonagem.Width) / 2) + 10%x
	
	menu.Initialize(Activity)
	
	imgSucesso.Bitmap = baseMod.imgParabens
	
	ExibirJanelaNivel
	
	imgVoltar.SendToBack
	baseMod.SetObjLayOut(imgVoltar, 1dip , 30dip , 54dip, 50dip,sXQ,sYQ)
	'imgVoltar.Top = (baseMod.alturaTela - imgVoltar.Height) / 2
	
End Sub

Sub ExibirJanelaNivel
	baseMod.SetObjLayOut(painelFundoSelNivel, 0 , 0 , 240dip * baseMod.indicePercentualTela,130dip * baseMod.indicePercentualTela,sXQ,sYQ)
	baseMod.SetObjLayOut(lblSelNivel, 0 , 0 , 400dip,50dip,sXQ,sYQ)
	lblSelNivel.Left = (baseMod.larguraTela - lblSelNivel.Width) / 2
	lblSelNivel.Text = AndroidResources1.GetApplicationString("selecionar_nivel")
	lblSelNivel.TextSize = baseMod.ScaleToSize(30,True,sXQ,sYQ)
	imgNivelFacil.Visible = True
	imgNivelMedio.Visible = True
	lblSelNivel.Visible = True
	painelFundoSelNivel.Visible = True
	painelModal.Tag = "Nivel"
	painelModal.Visible = True
	baseMod.SetObjLayOut(imgNivelFacil, 0 , 0 , 90dip * baseMod.indicePercentualTela,70dip * baseMod.indicePercentualTela,sXQ,sYQ)
	baseMod.SetObjLayOut(imgNivelMedio, 0 , 0 , 90dip * baseMod.indicePercentualTela,70dip * baseMod.indicePercentualTela,sXQ,sYQ)
	imgNivelFacil.Left = (imgNivelFacil.Width + baseMod.larguraTela) / 2 - 58%x
	imgNivelFacil.Top = (painelFundoSelNivel.Height - imgNivelFacil.Height) / 2
	imgNivelMedio.Left = imgNivelFacil.Left + imgNivelFacil.Width + 5%x
	imgNivelMedio.Top = (painelFundoSelNivel.Height - imgNivelMedio.Height) / 2
	
	painelFundoSelNivel.Top = lblSelNivel.Top + lblSelNivel.Height - 25dip
	painelFundoSelNivel.Left = (baseMod.larguraTela - painelFundoSelNivel.Width) / 2
	
End Sub

Sub SetarNivel(nivel As String)
	If nivel = "F" Then
		NbCols = 2
		NbLigs = 2
	Else
		NbCols = 3
		NbLigs = 2
	End If
	
	NbOfTiles = NbCols * NbLigs
	Dim Tiles(NbOfTiles) As ClsFloatingWindow
	Dim bd(NbOfTiles) As BitmapDrawable
	Dim Anim(NbOfTiles) As AnimationPlus
	
	imgNivelFacil.Visible = False
	imgNivelMedio.Visible = False
	painelModal.Visible = False
	lblSelNivel.Visible = False
	painelFundoSelNivel.Visible = False
	
	Timer1Q.Initialize("Timer", TimeBeforeScattering)
	TimerContagemRegressivaQ.Initialize("TimerContagemRegressivaQ",1000)

	carregarQuebraCabeca
	
End Sub

Sub carregarQuebraCabeca
	baseMod.indTelaQuebraCabecaLiberada = False
	Dim imagemSorteada As String =  arrayImagens(sortearImagemQuebraCabeca)
	'Se a Anterior for igual, sortear denovo
	If imagemAnterior = imagemSorteada Then
		imagemSorteada = arrayImagens(sortearImagemQuebraCabeca)
	End If
	'Marcar a anterior como sendo a atual para o proximo sorteio
	imagemAnterior = imagemSorteada
	
	Dim dadosImagem(3) As String
	dadosImagem = Regex.Split("#",imagemSorteada)
	If baseMod.getIdioma = "BR" OR baseMod.getIdioma2 = "pt_BR" Then
		lblTituloPersonagem.Text = dadosImagem(1)
	Else
		lblTituloPersonagem.Text = dadosImagem(2)
	End If
	
	LoadAPicture(File.DirAssets,dadosImagem(0))
	
End Sub

Sub sortearImagemQuebraCabeca As String
    Return Rnd(0, 12)
End Sub

#Region FuncoesQuebraCabeca
Sub LoadAPicture(Dir As String, FileName As String)
	' Loads the complete picture
	Dim bmp As Bitmap
	'bmp = AdjustBitmap(LoadBitmapSample(Dir, FileName, 54%x, 90%y), 54%x, 90%y)
	'bmp = AdjustBitmap(LoadBitmap(Dir, FileName), 85%x, 75%y)
	'If mapQuebraCabecas.Get(FileName) = Null Then
		'mapQuebraCabecas.Put(FileName,LoadBitmapSample(Dir, FileName, 54%x, 75%y))
		Dim Width As String = 54%x
		Dim Height As String = 75%y
		Dim larguraOriginal As String = 987dip
		Dim alturaOriginal As String = 603dip
		Dim RatioBmp, RatioIV As Float
		RatioBmp = larguraOriginal / alturaOriginal
		RatioIV = Width / Height
		Dim Diviseur As Float
		If RatioIV > RatioBmp Then
			Diviseur = alturaOriginal / Height
			bmp.Initialize3(LoadBitmapSample(File.DirAssets,FileName, Round(larguraOriginal / Diviseur / Density), Round(Height / Density)))
		Else
			Diviseur = larguraOriginal / Width
			bmp.Initialize3(LoadBitmapSample(File.DirAssets,FileName, Round(Width / Density), Round(alturaOriginal / Diviseur / Density)))
		End If
		
		'mapQuebraCabecas.Put(FileName,bmp)
	'End If
	'bmp = AdjustBitmap(mapQuebraCabecas.Get(FileName), 85%x, 75%y)
	'bmp = mapQuebraCabecas.Get(FileName)
	If bmp.Width < bmp.Height Then
		Msgbox("Please select an image wider than high (landscape orientation).", "Wrong orientation")
		Return
	End If
	'bmp = BP.ReduceColors(bmp) 'Helps to reduce the memory consumption
	ivEdges.Gravity = Gravity.CENTER
	ivEdges.SetBackgroundImage(bmp)

	' Computes the tiles size
	Dim SliceHeight, SliceWidth, SliceWidthDip, SliceHeightDip As Int
	SliceWidth = bmp.Width / NbCols
	SliceHeight = bmp.Height / NbLigs
	SliceWidthDip = SliceWidth * Density
	SliceHeightDip = SliceHeight * Density

	' ...and position
	Dim OffsetX, OffsetY, X, Y, i As Int
	OffsetX = ivEdges.Left + (ivEdges.Width - (bmp.Width * Density)) / 2
	OffsetY = ivEdges.Top + (ivEdges.Height - (bmp.Height * Density)) / 2

	' Creates the tiles (crops a part of the complete picture)
	Dim wRect As Rect
	For lig = 0 To NbLigs - 1
		For col = 0 To NbCols - 1
			i = lig * NbCols + col
			X = OffsetX + (SliceWidthDip * col)
			Y = OffsetY + (SliceHeightDip * lig)
			If Tiles(i).IsInitialized Then
				Tiles(i).RemoveDockingAreas
				Tiles(i).RemoveStickyEdges
				Tiles(i).Move(X, Y, True)
				Tiles(i).Resize(SliceWidthDip, SliceHeightDip)
			Else
				Tiles(i).Initialize(Activity, X, Y, SliceWidthDip, SliceHeightDip, Me)
				Tiles(i).EnableTitleBar(False)
				Tiles(i).SetBorder(0, 0)
				Tiles(i).MinimumWidthAfterResize = 20dip
				Tiles(i).MinimumHeightAfterResize = 20dip
				Tiles(i).TouchSlop = 0 'No latency between the Touch event and the move
				Tiles(i).StickyAreaColor = Colors.Transparent
				Tiles(i).DockingAreaColor = Colors.Transparent
				Tiles(i).MinimumCoveredSurfaceForDocking = 60
				Tiles(i).SetOnDockListener("Win_Dock")
				Tiles(i).SetOnUndockListener("Win_Undock")
			End If
			bd(i).Initialize(BP.Crop(bmp, SliceWidth * col, SliceHeight * lig, SliceWidth, SliceHeight))
			Tiles(i).SetBackground(bd(i))
			Tiles(i).StillVisible = Min(SliceWidthDip * EnlargeFactor, SliceHeightDip * EnlargeFactor) + 2dip
			Tiles(i).AddStickyEdge(0, 50%x - Round(SliceWidthDip / 2)) ' Left
			Tiles(i).AddStickyEdge(2, 50%x - Round(SliceWidthDip / 2)) ' Right
			wRect.Initialize(X, Y, X + SliceWidthDip, Y + SliceHeightDip)
			Tiles(i).AddDockingArea(wRect)
		Next
	Next

	' Replaces the complete picture by a silhouette
	cvEdges.Initialize(ivEdges)
	cvEdges.DrawColor(Colors.Transparent)
	X = (ivEdges.Width - (bmp.Width * Density)) / 2 + 5dip
	Y = (ivEdges.Height - (bmp.Height * Density)) / 2 + 5dip
'	wRect.Initialize(X, Y, X + (SliceWidthDip * NbCols) - 2dip, Y + (SliceHeightDip * NbLigs) - 2dip)
'	cvEdges.DrawRect(wRect, Colors.RGB(215,215,215), False, 2dip)
'	Dim pnl As Panel
'	pnl.Initialize("pnl")
'	pnl.Color = Colors.ARGB(150,215,215,215)
'	Activity.AddView(pnl,OffsetX,OffsetY, bmp.Width,bmp.Height)
'	pnl.SendToBack
	
'	Dim btmp As Bitmap
'	btmp.Initialize(File.DirAssets,FileName)
'	Dim btmpPB As Bitmap = baseMod.imagemPretoeBranco(btmp)
	
	'Esboço Traseiro do Quebra-Cabeça
	If imgVwEsbocoQuebraCabeca.IsInitialized = False Then
		imgVwEsbocoQuebraCabeca.Initialize("imgVwEsbocoQuebraCabeca")
	End If
	imgVwEsbocoQuebraCabeca.RemoveView
	If mapEsboco.Get(FileName) = Null Then
		mapEsboco.Put(FileName,imgVwEsbocoQuebraCabeca.LoadScaledBitmap(File.DirAssets, FileName, bmp.Width * baseMod.indiceEsbocoQuebraCabeca,bmp.Height * baseMod.indiceEsbocoQuebraCabeca,  True))
	End If
	imgVwEsbocoQuebraCabeca.BackgroundBitmap = mapEsboco.Get(FileName)
	imgVwEsbocoQuebraCabeca.BackgroundBitmap = imgVwEsbocoQuebraCabeca.AlterColors(imgVwEsbocoQuebraCabeca.BackgroundBitmap, 0, 0)
	Activity.AddView(imgVwEsbocoQuebraCabeca,OffsetX,OffsetY,  bmp.Width * baseMod.indiceEsbocoQuebraCabeca,bmp.Height * baseMod.indiceEsbocoQuebraCabeca)
	imgVwEsbocoQuebraCabeca.ChangeBackgroundAlpha(40)
	imgVwEsbocoQuebraCabeca.ChangeAlpha(40)
	imgVwEsbocoQuebraCabeca.SendToBack
	
	' When the timer ends, the tiles are scattered
	Timer1Q.Enabled = True
	
	'Contador da Contagem Regressiva
	lblContador.Visible = True
	lblContador.BringToFront
	baseMod.SetObjLayOut(lblContador, 0dip , 0dip , 160, 200,sXQ,sYQ)
	lblContador.TextSize = baseMod.ScaleToSize(100,True,sXQ,sYQ)
	lblContador.Left = (baseMod.larguraTela / 2) - 10%x
	lblContador.Top = (baseMod.alturaTela / 2) - 20%x
	lblContador.TextColor = Colors.ARGB(210,255,255,255)
	contador = 3
	TimerContagemRegressivaQ.Enabled = True
	lblContador.Text = contador
	
	Try
	Dim ref As Reflector
	ref.Target = bmp
	ref.RunMethod("recycle")
	Catch
	End Try
	
	
	'If AnimBtn.IsInitialized Then DrawAttentionOnButton
	
	Try
		Dim corLinha As String = Colors.RGB(173,173,173)
		Dim Canvas1 As Canvas
		Canvas1.Initialize(imgVwEsbocoQuebraCabeca)
		Canvas1.DrawLine(0dip, SliceHeightDip , imgVwEsbocoQuebraCabeca.Width,  SliceHeightDip, corLinha, 1dip)
		
		Dim Canvas2 As Canvas
		Canvas2.Initialize(imgVwEsbocoQuebraCabeca)
		Canvas2.DrawLine(SliceWidthDip , 0dip ,SliceWidthDip,imgVwEsbocoQuebraCabeca.Height, corLinha, 1dip)
		
		Dim Canvas3 As Canvas
		Canvas3.Initialize(imgVwEsbocoQuebraCabeca)
		Canvas3.DrawLine(SliceWidthDip * 2 , 0dip ,SliceWidthDip * 2,imgVwEsbocoQuebraCabeca.Height, corLinha, 1dip)
	Catch
	End Try
	
End Sub

'Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int) As Bitmap
'	' Resizes the given picture
'	Dim R As Reflector
'	Dim b As Bitmap
'	b = R.RunStaticMethod("android.graphics.Bitmap", "createScaledBitmap", _
'			Array As Object(Original, Width, Height, True), _
'			Array As String("android.graphics.Bitmap", "java.lang.int", "java.lang.int", "java.lang.boolean"))
'	R.Target = Original
'	R.RunMethod("recycle")
'	Return b
'End Sub

'Sub AdjustBitmap(bmp As Bitmap, Width As Int, Height As Int) As Bitmap
'	' Resizes the bitmap to fit the given dimensions
'	Dim RatioBmp, RatioIV As Float
'	RatioBmp = bmp.Width / bmp.Height
'	RatioIV = Width / Height
'	Dim Diviseur As Float
'	If RatioIV > RatioBmp Then
'		Diviseur = bmp.Height / Height
'		bmp = CreateScaledBitmap(bmp, Round(bmp.Width / Diviseur / Density), Round(Height / Density))
'	Else
'		Diviseur = bmp.Width / Width
'		bmp = CreateScaledBitmap(bmp, Round(Width / Density), Round(bmp.Height / Diviseur / Density))
'	End If
'	Return bmp
'End Sub


Sub Win_Dock(Window As ClsFloatingWindow, DockRect As Rect)
		' Checks if all tiles are docked
		For i = 0 To NbOfTiles - 1
			'Som de Encaixe da Peça
			Try
				MPEncaixe.Play
			Catch
		     
		  	End Try
			If Not(Tiles(i).IsDocked) Then Return
		Next
			
		painelModal.BringToFront
		imgSucesso.BringToFront
		ivEdges.SendToBack
		'ToastMessageShow("Parabéns, você conseguiu !!!", False)
		ExibirSucessoMontagem
		exibirSomConclusaoMontagem
End Sub

Sub Win_Undock(Window As ClsFloatingWindow)
	Window.Resize(Window.getWidth * EnlargeFactor, Window.getHeight * EnlargeFactor)
End Sub

'Sub DrawAttentionOnButton
'	AnimBtn.Duration = TimeBeforeScattering / 2
'	AnimBtn.RepeatCount = 0
''	AnimBtn.Start(btnFolder)
'End Sub

#End Region

Sub Activity_Resume
bannerInterAdmob.ResumeActivity
End Sub

Sub exibirBannerAdmobInter
	bannerInterAdmob.ExibirBanner
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed = True Then
		Try
		MPFundoQuebraCabeca.Pause
		Catch
		End Try
	End If
End Sub

Sub Timer_Tick
	Timer1Q.Enabled = False
	TimerContagemRegressivaQ.Enabled = False
	lblContador.Visible = False

	' Makes the tiles bigger to ease their handling (they will be resized when they dock)
	' then prepares the animations to scatter the tiles
	Dim NbPositions, NewPosition, DeltaY As Int
	NbPositions = Ceil(NbOfTiles / 2)
	For i = 0 To NbOfTiles - 1
		Tiles(i).Resize(Tiles(i).getWidth * EnlargeFactor, Tiles(i).getHeight * EnlargeFactor)
		Dim PositionIsFree As Boolean
		Do Until PositionIsFree
			NewPosition = (Rnd(0, NbPositions) * (90%y - Tiles(i).getHeight) / (NbPositions - 1)) + 5%y
			PositionIsFree = True
			For j = 0 To i - 1
				' The tile position must be unique (avoids tiles completely hidden by other tiles)
				If j Mod 2 = i Mod 2 Then
					If NewPosition = Tiles(j).getTag + Tiles(j).getTop Then
						PositionIsFree = False
						Exit
					End If
				End If
			Next
		Loop
		DeltaY = NewPosition - Tiles(i).getTop
		Tiles(i).SetTag(DeltaY)
		If i Mod 2 = 0 Then
			Anim(i).InitializeTranslate("Anim", 0, 0, -Tiles(i).getLeft, DeltaY)
		Else
			Anim(i).InitializeTranslate("Anim", 0, 0, 100%x - Tiles(i).getWidth - Tiles(i).getLeft, DeltaY)
		End If
		Anim(i).SetInterpolator(Anim(i).INTERPOLATOR_ANTICIPATE_OVERSHOOT)
	Next

	' Starts the animations
	For i = 0 To NbOfTiles - 1
		Anim(i).Duration = 700
		Anim(i).Start(Tiles(i).AsPanel)
	Next
	
	baseMod.indTelaQuebraCabecaLiberada = True
	
End Sub

Sub TimerContagemRegressivaQ_Tick
	If contador <> 0 Then
	contador = contador - 1
	lblContador.Text = contador
	End If
End Sub

Sub Anim_AnimationEnd
	' Moves the tiles to their final position (sticked to an edge)
	For i = 0 To NbOfTiles - 1
		If Sender = Anim(i) Then
			If i Mod 2 = 0 Then
				Tiles(i).Move(0, Tiles(i).getTop + Tiles(i).getTag, True)
			Else
				Tiles(i).Move(100%x - Tiles(i).getWidth, Tiles(i).getTop + Tiles(i).getTag, True)
			End If
			Exit
		End If
	Next
End Sub

Sub AnimButton_AnimationEnd
	AnimBtn = Null
End Sub

Sub ExibirSucessoMontagem
	baseMod.indTelaQuebraCabecaLiberada = False
	imgSucesso.Visible = True
	painelModal.Tag = "Sucesso"
	painelModal.Visible = True
	baseMod.SetObjLayOut(imgSucesso, 0 , 0 , 235dip * baseMod.indicePercentualTela,189dip * baseMod.indicePercentualTela,sXQ,sYQ)
	imgSucesso.Left = (baseMod.larguraTela - imgSucesso.Width) / 2
	imgSucesso.Top = (baseMod.alturaTela - imgSucesso.Height) / 2
	aimacaoSucessoResposta.InitializeScaleCenter("aimacaoSucessoResposta", 0.1, 0.1, 1, 1, imgSucesso)
	aimacaoSucessoResposta.Duration = 600
	aimacaoSucessoResposta.RepeatCount = 0
	aimacaoSucessoResposta.Start(imgSucesso)
End Sub

Sub exibirSomConclusaoMontagem()
	If baseMod.indEfeitosSonorosHabilitado = True Then
		MPFundoQuebraCabeca.Pause
		Dim arquivoSomCarregar As String 
		arquivoSomCarregar = "sucessoquiz.mp3"
		MpSomConclusaoMontagem.Initialize2("MpSomConclusaoMontagem")
		MpSomConclusaoMontagem.SetVolume(0.9,0.9)
		MpSomConclusaoMontagem.Load(File.DirAssets, arquivoSomCarregar)
		MpSomConclusaoMontagem.Looping = False
		MpSomConclusaoMontagem.Play
	End If
End Sub

Sub imgMenu_Click
	menu.ExibirMenu()
End Sub

Sub imgSucesso_click
	If baseMod.indEfeitosSonorosHabilitado = False Then 'Se o som de sucesso estiver desativado, habilitar o recomeço no clique do botão
		MPFundoQuebraCabeca.Play
		reiniciarJogo
	End If
End Sub

Sub painelModal_click
	If baseMod.indEfeitosSonorosHabilitado = False Then 'Se o som de sucesso estiver desativado, habilitar o recomeço no clique do botão
		If painelModal.Tag = "Sucesso" Then
			MPFundoQuebraCabeca.Play
			reiniciarJogo
		End If
	End If
End Sub

Sub reiniciarJogo
	baseMod.indTelaQuebraCabecaLiberada = False
	carregarQuebraCabeca
	painelModal.Visible = False
	imgSucesso.Visible = False
	Timer1Q.Interval = TimeBeforeScattering * 2
	Timer1Q.Enabled = True
	lblContador.Visible = True
	contador = 3
	TimerContagemRegressivaQ.Enabled = True
End Sub

Sub imgNivelFacil_Click
	nivelSelecionado = "F"
	cliqueBotaoNivel(imgNivelFacil)
End Sub
Sub imgNivelMedio_Click
	nivelSelecionado = "M"
	cliqueBotaoNivel(imgNivelMedio)
End Sub

Sub cliqueBotaoNivel(imagemOrigem As ImageView)
'	AnimacaoCliqueBotaoNivel.Stop(imagemOrigem)
'	AnimSet.Stop(imagemOrigem)
'	AnimacaoCliqueBotaoNivel.InitializeScaleCenter("AnimacaoCliqueBotaoNivel", 0.9, 0.9, 1, 1, imagemOrigem)
'	AnimacaoCliqueBotaoNivel.RepeatCount = 1
'	AnimacaoCliqueBotaoNivel.RepeatMode = AnimacaoCliqueBotaoNivel.REPEAT_REVERSE
'	
'	AnimSet.Initialize(False)
'	AnimSet.Duration = 300
'	AnimSet.PersistAfter = False
'	AnimSet.AddAnimation(AnimacaoCliqueBotaoNivel)
'	AnimSet.Start(imagemOrigem)
'	
'	If baseMod.indEfeitosSonorosHabilitado = True Then
'		MPEfeitosSonoros.Initialize2("MPEfeito")
'		MPEfeitosSonoros.SetVolume(0.7,0.7)
'		MPEfeitosSonoros.Load(File.DirAssets, "cliqueBotao.mp3")
'		MPEfeitosSonoros.Looping = False
'		MPEfeitosSonoros.Play
'	End If
	SetarNivel(nivelSelecionado)
End Sub

Sub AnimacaoCliqueBotaoNivel_AnimationEnd
	SetarNivel(nivelSelecionado)
End Sub

Sub AnimacaoCliqueBotao_AnimationEnd
	Activity.Finish
	baseMod.SetAnimation("left_right","left_right1")
End Sub

Sub setarStatusSomFundo
Try
If baseMod.indMusicaFundoHabilitado = True Then
	MPFundoQuebraCabeca.Play
Else
	MPFundoQuebraCabeca.Pause
End If
Catch
End Try
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	 If KeyCode = KeyCodes.KEYCODE_BACK OR KeyCode = KeyCodes.KEYCODE_HOME Then
	 	Try
			MPFundoQuebraCabeca.Pause
		Catch
		End Try
		Activity.Finish
		baseMod.SetAnimation("left_right","left_right1")
	End If
End Sub

Sub MpSomConclusaoMontagem_Complete
	Try
		MPFundoQuebraCabeca.Play
	Catch
	End Try
	reiniciarJogo
End Sub
Sub imgVoltar_Click
	Try
		MPFundoQuebraCabeca.Pause
	Catch
	End Try
	baseMod.animarBotao(imgVoltar,2)
	'Após Concluído, vai para AnimacaoCliqueBotao_AnimationEnd
End Sub