﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim MPFundoMar As MediaPlayer
	Dim sY As Long
	Dim sX As Long
	'Dim imgFundo As Bitmap
	'Dim imgCaixaFundoTexto As Bitmap
	'Dim mapImagensMiniaturas As Map
	Dim mapSomPersoganem As Map
	'Dim mapImagemGrandePersonagem As Map
	Dim primeiroAcesso As Boolean
	Dim bitmapImgGrande As Bitmap
	Dim bitmapCaixaFundo As Bitmap
	Dim bitmapMiniatura As Bitmap
	Dim bitmapFundo As Bitmap
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private imgPolvo,imgPeixe As ImageView
	Private imgGrd As ImageView
	Dim AnimacaoLoopPersonagem,AnimacaoSaidaPersonagem,AnimacaoEntrada,AnimacaoCaixaTexto,AnimacaoBannerAdmob As AnimationPlus
	Dim centroImagemX As String
	Dim centroImagemY As String
	Private caixaFundoTexto As Panel
	'Dim TemporizadorSomVolMusicaFundo As Timer
	Private scrwBarraCima As HorizontalScrollView
	Dim lblTextoPortugues,lblTextoIngles As Label
	Dim AnimSet As AnimationSet
	'Private imgSom As ImageView
	Dim TimeFont As Typeface
	Dim menu As menuMod
	Dim textoPersonagemPtBr,textoPersonagemEn As String
	Dim indImagemGrandeLiberada As Boolean = True
	Private imgBtnEsquerda As ImageView
	Private imgBtnDireita As ImageView
	Dim destinoXPersonagemAnimacao As String
	Private imgBtnVoltar As ImageView
	Private painelBannerAdmob As Panel
	Dim bnnAdMob As bannerAdmobMod
	Dim temporizadorExibirBannerAdmob,temporizadorOcultarBannerAdmob As Timer
	Dim btm As BitmapDrawable
	Dim larguraPersonagem As String
	Dim alturaPersonagem As String 
	Dim bannerInterAdmob As bannerAdmobInterModule
	Dim imgPers As ImageView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	primeiroAcesso = FirstTime
	sY = baseMod.alturaTela
	sX = baseMod.larguraTela
	montarLayout
End Sub

Sub montarLayout
	Activity.Tag = "frmFundoMar"
	Activity.LoadLayout("vwFundoMar")
	
	baseMod.identificarDispositivo
	bannerInterAdmob.Initialize
	
	'Fazer apenas na primeira vez que carregou a tela
	If primeiroAcesso = True Then
	
	'Música de Fundo
		Try
			MPFundoMar.Initialize2("MP")
			MPFundoMar.SetVolume(0.5,0.5)
			MPFundoMar.Load(File.DirAssets, "bolhasFundo.mp3") 'Music not music.
			MPFundoMar.Looping = True
		Catch
	     
	  	End Try
		
		'Imagem de Fundo
		'imgFundo.Initialize3(LoadBitmapSample(File.DirAssets, "fundoDoMar.png",baseMod.larguraTela,baseMod.alturaTela))
		'imgCaixaFundoTexto.Initialize3(LoadBitmapSample(File.DirAssets,"fundoTextosFala.png",baseMod.larguraTela - 30%x,baseMod.alturaTela  - 30%y))
				
		'Inicializar Mapa de Imagens
		'mapImagensMiniaturas.Initialize
		'mapImagemGrandePersonagem.Initialize
		
		'Inicializar o Mapa do Som dos Personagens
		mapSomPersoganem.Initialize
		
	End If
	
	bitmapFundo.InitializeSample(File.DirAssets, "fundoDoMar.png",baseMod.larguraTela,baseMod.alturaTela)
	Activity.SetBackgroundImage(bitmapFundo)
		
	setarStatusSomFundo
	
	'trocarImagemSomFundo
	
	TimeFont = Typeface.LoadFromAssets("HVD_Bodedo.ttf")
	Dim p As PhoneEvents
	Dim PID As PhoneId
	p.InitializeWithPhoneState("ttsMusicaFundo",PID) 'not really required. Use Initialize instead and do not dim PID.
	
	caixaFundoTexto.Initialize("caixaFundoTexto")
	bitmapCaixaFundo.InitializeSample(File.DirAssets,"fundoTextosFala.png",baseMod.larguraTela - 30%x,baseMod.alturaTela  - 30%y)
	caixaFundoTexto.SetBackgroundImage(bitmapCaixaFundo)
	
	Dim larguraCaixaFundoTexto As String = (baseMod.larguraTela / 2)  + 2%x
	Dim alturaCaixaFundoTexto As String = (baseMod.alturaTela / 2) - 2%y
	Dim topCaixaFundoTexto As String = ((baseMod.alturaTela - alturaCaixaFundoTexto) / 2)
	Dim leftCaixaFundoTexto As String = 1%x + 20dip
	
	Activity.AddView(caixaFundoTexto, leftCaixaFundoTexto,topCaixaFundoTexto,larguraCaixaFundoTexto ,alturaCaixaFundoTexto ) ' Posicionar no zero, pois quando for exibir será reposicionada de acordo com o tamanho da tela
	caixaFundoTexto.Visible = False
	lblTextoPortugues.Initialize("lblTextoPortugues")
	lblTextoIngles.Initialize("lblTextoIngles")
	lblTextoPortugues.Typeface = TimeFont
	lblTextoIngles.Typeface = TimeFont
	lblTextoIngles.TextSize = 16dip 'baseMod.tamanhoFonteTextosPersonagens
	lblTextoPortugues.TextSize = 16dip 'baseMod.tamanhoFonteTextosPersonagens
	lblTextoPortugues.TextColor = Colors.RGB(107,87,57)
	lblTextoIngles.TextColor = Colors.RGB(107,87,57)
	lblTextoIngles.Gravity = Gravity.CENTER
	lblTextoPortugues.Gravity = Gravity.CENTER
	
	'Botões Scroll
	imgBtnEsquerda.Width = baseMod.larguraBotaoScrool
	imgBtnEsquerda.Height = baseMod.larguraBotaoScrool
	imgBtnDireita.Width = baseMod.larguraBotaoScrool
	imgBtnDireita.Height = baseMod.larguraBotaoScrool
	
	imgBtnDireita.Left = baseMod.larguraTela - imgBtnDireita.Width
	
	'Labels do TExto
	Dim leftLabelTexto As String = caixaFundoTexto.left + 2%x
	Dim alturaLabelTexto As String = (caixaFundoTexto.Height / 2) - 5%y
	Dim topLabelTextoPortugues As String = caixaFundoTexto.top + 5%y
	Dim topLabelTextoIngles As String = topLabelTextoPortugues + alturaLabelTexto
	
	Activity.AddView(lblTextoPortugues,leftLabelTexto,topLabelTextoPortugues,caixaFundoTexto.Width - 10%x   ,alturaLabelTexto)  ' Posicionar no zero, pois quando for exibir será reposicionada de acordo com o tamanho da tela
	Activity.AddView(lblTextoIngles, leftLabelTexto,topLabelTextoIngles,caixaFundoTexto.Width - 10%x ,alturaLabelTexto) ' Posicionar no zero, pois quando for exibir será reposicionada de acordo com o tamanho da tela
	
	'Posicionar a Barra de Cima ( Scroll )
	Dim leftBarraScroll As String = imgBtnEsquerda.Width
	scrwBarraCima.SetLayout( leftBarraScroll,0,baseMod.larguraTela - (baseMod.larguraBotaoScrool * 2 ),baseMod.alturaBarraScrool)
	
	carregarScroolListaPersonagens
	
	menu.Initialize(Activity)
	
	baseMod.SetObjLayOut(imgBtnVoltar, 1dip ,  0dip , 54dip, 50dip,sX,sY)
	imgBtnVoltar.Top = baseMod.alturaTela - imgBtnVoltar.Height + 5dip
	
	'Banner ADMOB
	If bnnAdMob.IsInitialized = False Then
		Dim leftBanner As String = (baseMod.larguraTela - baseMod.larguraBannerAdmob) / 2
		Dim topBanner As String = baseMod.alturaTela - baseMod.alturaBannerAdmob
		bnnAdMob.Initialize(Activity,leftBanner,topBanner ,baseMod.larguraBannerAdmob,baseMod.alturaBannerAdmob)
	End If
	
	temporizadorExibirBannerAdmob.Initialize("temporizadorExibirBannerAdmob",baseMod.tempoExibirBanner)
	temporizadorOcultarBannerAdmob.Initialize("temporizadorOcultarBannerAdmob",baseMod.tempoOcultarBanner)
	temporizadorExibirBannerAdmob.Enabled = True
	
	
End Sub


Sub scrwBarraCima_ScrollChanged(Position As Int)

End Sub
'
Sub setarStatusSomFundo
Try
	If baseMod.indMusicaFundoHabilitado = True Then
		MPFundoMar.SetVolume(1,1)
		MPFundoMar.Play
	Else
		MPFundoMar.Pause
	End If
Catch
	End Try
End Sub

'Sub trocarImagemSomFundo
'baseMod.trocarImagemSomFundo(imgSom,baseMod.indSomFundoMarHabilitado)
'End Sub

Sub Activity_Resume
	bannerInterAdmob.ResumeActivity
	posicionarElementosTela
	moverPersonagemLoop(imgGrd)
	setarStatusSomFundo
End Sub

Sub exibirBannerAdmobInter
	bannerInterAdmob.ExibirBanner
End Sub

Sub posicionarElementosTela
	'Imagem Grande
	imgGrd.Left = ((baseMod.larguraTela - imgGrd.Width) / 2)  + 25%x
	imgGrd.Top = (baseMod.alturaTela - imgGrd.Height) / 2
	
	'Setar o tamanho do Personagem
	larguraPersonagem = (baseMod.larguraTela / 2) - 10%x
	alturaPersonagem = (baseMod.larguraTela / 2) - 15%x
	imgGrd.Width = larguraPersonagem
	imgGrd.Height = alturaPersonagem
	
End Sub

'Sub VR_Result (Success As Boolean, Texts As List)
'	If Success = True Then
'		If Texts.Get(0) = "fish" Then
'			carregarPeixe
'		End If
		'TTS1.Speak("Peixe", True)
'	End If
'End Sub


Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed = True Then
		MPFundoMar.Pause
		Activity.Finish
	End If
End Sub

Sub carregarScroolListaPersonagens
	Dim leftPersonagemScrool As String = 5
	Dim ArrayPersonagens(12) As String
	
	'IMAGEM PEQUENA # IMAGEM GRANDE # PORTUGUES # INGLES
	ArrayPersonagens(0) = "peixe_pq.png#peixe_grd.png#Peixe#Fish"
	ArrayPersonagens(1) = "polvo_pq.png#polvo_grd.png#Polvo#Octopus"
	ArrayPersonagens(2) = "arraia_pq.png#arraia_grd.png#Arraia#Ray Fish"
	ArrayPersonagens(3) = "siri_pq.png#siri_grd.png#Siri#Crab"
	ArrayPersonagens(4) = "tartaruga_pq.png#tartaruga_grd.png#Tartaruga Marinha#Sea Turtle"
	ArrayPersonagens(5) = "tubarao_pq.png#tubarao_grd.png#Tubarão#Shark"
	ArrayPersonagens(6) = "estreladomar_pq.png#estreladomar_grd.png#Estrela do Mar#Starfish"
	ArrayPersonagens(7) = "baleia_pq.png#baleia_grd.png#Baleia#Whale"
	ArrayPersonagens(8) = "golfinho_pq.png#golfinho_grd.png#Golfinho#Dolphin"
	ArrayPersonagens(9) = "camarao_pq.png#camarao_grd.png#Camarão#Shrimp"
	ArrayPersonagens(10) = "cavalo-marinho_pq.png#cavalo-marinho_grd.png#Cavalo Marinho#Seahorse"
	ArrayPersonagens(11) = "lula_pq.png#lula_grd.png#Lula#Squid"
	
	For i = 0 To 11
		Dim dadosPersonagens(2) As String
		dadosPersonagens = Regex.Split("#", ArrayPersonagens(i))
		imgPers.Initialize("imgPers")
		imgPers.Tag = ArrayPersonagens(i)
		imgPers.Gravity = Gravity.FILL
		'If primeiroAcesso = True Then
			'Carregar Todas as imagens no MAP
		'	mapImagensMiniaturas.Put(i,LoadBitmapSample(File.DirAssets,dadosPersonagens(0),baseMod.larguraMiniauras,baseMod.larguraMiniauras))
		'End If
		'imgPers.SetBackgroundImage( mapImagensMiniaturas.GetValueAt(i))
		bitmapMiniatura.InitializeSample(File.DirAssets,dadosPersonagens(0),baseMod.larguraMiniauras,baseMod.larguraMiniauras)
		'imgPers.SetBackgroundImage(LoadBitmapSample(File.DirAssets,dadosPersonagens(0),baseMod.larguraMiniauras,baseMod.larguraMiniauras))
		imgPers.SetBackgroundImage(bitmapMiniatura)
		scrwBarraCima.Panel.AddView(imgPers,leftPersonagemScrool,5,baseMod.larguraMiniauras, baseMod.larguraMiniauras)
		scrwBarraCima.Panel.Width = scrwBarraCima.Panel.Width + baseMod.larguraMiniauras
		leftPersonagemScrool = leftPersonagemScrool + baseMod.larguraMiniauras + 10dip
	Next
	scrwBarraCima.Panel.Width = scrwBarraCima.Panel.Width + (baseMod.larguraMiniauras * 2)
End Sub

Sub carregarPersonagem(imgGrande As String,descricaoPersonagemPortugues As String,descricaoPersonagemIngles As String)
	
	destinoXPersonagemAnimacao = ((baseMod.larguraTela - imgGrd.Width) / 2) - 25%x

	'Redimensionar Botões
	lblTextoPortugues.TextSize = baseMod.ScaleToSize(18,True,sX,sY)
	lblTextoIngles.TextSize = baseMod.ScaleToSize(18,True,sX,sY)
	
	'Posicionar os Elementos na tela de acordo com a dimensão da tela
	posicionarElementosTela

	'If mapImagemGrandePersonagem.Get(imgGrande) = Null Then
	'	mapImagemGrandePersonagem.Put(imgGrande,LoadBitmapSample(File.DirAssets, imgGrande,larguraPersonagem,alturaPersonagem))
	'End If
	imgGrd.Visible = True
	'imgGrd.SetBackgroundImage(mapImagemGrandePersonagem.Get(imgGrande))
	bitmapImgGrande.InitializeSample(File.DirAssets, imgGrande,larguraPersonagem,alturaPersonagem)
	imgGrd.SetBackgroundImage(bitmapImgGrande)
	indImagemGrandeLiberada = False
	AnimacaoEntrada.InitializeTranslate("AnimacaoEntrada", 600dip, 0dip,destinoXPersonagemAnimacao,0dip)
	AnimacaoEntrada.Duration = 2500
	AnimacaoEntrada.SetInterpolator(AnimacaoEntrada.INTERPOLATOR_OVERSHOOT)
	AnimacaoEntrada.PersistAfter = True
	
	If AnimacaoEntrada.IsInitialized Then
		AnimacaoEntrada.Stop(imgGrd)
		Activity.Invalidate
		AnimacaoEntrada.Start(imgGrd)
	End If
	
	If baseMod.indTextoPtHabilitado = True OR baseMod.indTextoEnHabilitado = True Then
		caixaFundoTexto.Visible = True
		'Animacao da Caixa
		AnimacaoCaixaTexto.InitializeAlpha("AnimacaoCaixaTexto", 0, 1)
		AnimacaoCaixaTexto.Duration = 6000
		AnimacaoCaixaTexto.SetInterpolator(AnimacaoCaixaTexto.INTERPOLATOR_OVERSHOOT)
		If AnimacaoCaixaTexto.IsInitialized Then
			AnimacaoCaixaTexto.Stop(caixaFundoTexto)
			Activity.Invalidate
			AnimacaoCaixaTexto.Start(caixaFundoTexto)
		End If
	End If
	
	'Texto do Personagens
	If baseMod.indTextoPtHabilitado = True Then
		lblTextoPortugues.Visible = True
		lblTextoPortugues.Text = descricaoPersonagemPortugues
		'Dim su2 As StringUtils
		'lblTextoPortugues.Height = su2.MeasureMultilineTextHeight(lblTextoPortugues, lblTextoPortugues.Text)
		textoPersonagemPtBr = descricaoPersonagemPortugues
	End If
		
	If baseMod.indTextoEnHabilitado = True Then
		lblTextoIngles.Visible = True
		lblTextoIngles.Text = descricaoPersonagemIngles
		textoPersonagemEn = descricaoPersonagemIngles
	End If

End Sub

'Sub limparObjetosMemoria
'If imgGrd.IsInitialized Then imgGrd.SetBackgroundImage(Null)
'If imgPers.IsInitialized Then imgPers.SetBackgroundImage(Null)
'Activity.SetBackgroundImage(Null)
'If caixaFundoTexto.IsInitialized Then caixaFundoTexto.SetBackgroundImage(Null)
'If bitmapImgGrande.IsInitialized Then recycleObjeto(bitmapImgGrande)
'If bitmapCaixaFundo.IsInitialized Then recycleObjeto(bitmapCaixaFundo)
'If bitmapMiniatura.IsInitialized Then recycleObjeto(bitmapMiniatura)
'If bitmapFundo.IsInitialized Then recycleObjeto(bitmapFundo)
'Dim r As Reflector
'r.RunStaticMethod("java.lang.System", "gc", Null, Null)
'Log("Possivel limpeza")
'End Sub
'
'Sub recycleObjeto(imagem As Bitmap)
'Dim ref As Reflector
'ref.Target = imagem
'ref.RunMethod("recycle")
'End Sub

Sub falarTextoPersonagem
		MPFundoMar.SetVolume(0.1,0.1)
		If baseMod.indTextoPtHabilitado = True Then
			baseMod.falarTextoPortugues(textoPersonagemPtBr)
		End If
		
		If  baseMod.indTextoEnHabilitado = True Then
			baseMod.falarTextoIngles(textoPersonagemEn)
		End If
End Sub

Sub imgPers_Click
If indImagemGrandeLiberada = True Then
	Dim imagemPersonagemClicada As ImageView = Sender
	Dim dadosPersonagens(3) As String
	dadosPersonagens = Regex.Split("#", imagemPersonagemClicada.Tag)
	carregarPersonagem(dadosPersonagens(1),dadosPersonagens(2),dadosPersonagens(3))'Buscar a Imagem Grande, posição 1
	imgGrd.Tag = imagemPersonagemClicada.Tag
End If
End Sub

Sub ttsMusicaFundo_TextToSpeechFinish (Intent As Intent)
MPFundoMar.SetVolume(0.5,0.5)
End Sub

Sub AnimacaoEntrada_AnimationEnd
indImagemGrandeLiberada = True
moverPersonagemLoop(imgGrd)
falarTextoPersonagem
End Sub

Sub moverPersonagemLoop(objetoImagem As ImageView)
	destinoXPersonagemAnimacao = ((baseMod.larguraTela - imgGrd.Width) / 2) - 25%x
	AnimacaoLoopPersonagem.InitializeTranslate("AnimacaoLoopPersonagem", destinoXPersonagemAnimacao, 0dip , 0dip, 40dip)
	AnimacaoLoopPersonagem.StartOffset = 50
	AnimacaoLoopPersonagem.SetInterpolator(AnimacaoLoopPersonagem.INTERPOLATOR_CYCLE)
	AnimacaoLoopPersonagem.RepeatCount = AnimacaoLoopPersonagem.REPEAT_INFINITE
	AnimacaoLoopPersonagem.RepeatMode = AnimacaoLoopPersonagem.REPEAT_REVERSE
	
	AnimSet.Initialize(False)
	AnimSet.AddAnimation(AnimacaoLoopPersonagem)
	AnimSet.Duration = 2000
	AnimSet.PersistAfter = True
	AnimSet.Start(objetoImagem)
End Sub

'Sub imgSom_Click
'	setarStatusSomFundo
'End Sub

Sub imgGrd_Click
	falarTextoPersonagem
End Sub

Sub AnimacaoSaidaPersonagem_AnimationEnd
imgGrd.Visible = False
End Sub

Sub lblTextoPortugues_Click
	falarTextoPersonagem
End Sub

Sub lblTextoIngles_Click
	falarTextoPersonagem
End Sub

Sub imgMenu_Click
	menu.ExibirMenu()
End Sub

Sub Activity_Click

End Sub

Sub imgBtnEsquerda_Click
	scrwBarraCima.ScrollPosition = scrwBarraCima.ScrollPosition - baseMod.larguraMiniauras
End Sub

Sub imgBtnDireita_Click
	scrwBarraCima.ScrollPosition = scrwBarraCima.ScrollPosition + baseMod.larguraMiniauras
End Sub

Sub AnimacaoCliqueBotao_AnimationEnd
	MPFundoMar.Pause
	Activity.Finish
	baseMod.SetAnimation("left_right","left_right1")
End Sub

Sub tratarFalhaRecebimentoBanner
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	 If KeyCode = KeyCodes.KEYCODE_BACK OR KeyCode = KeyCodes.KEYCODE_HOME Then
	 	MPFundoMar.Pause
		Activity.Finish
		baseMod.SetAnimation("left_right","left_right1")
	End If
End Sub
Sub imgBtnVoltar_Click
	baseMod.animarBotao(imgBtnVoltar,2)
	'Após Concluído, vai para AnimacaoCliqueBotao_AnimationEnd
End Sub

Sub temporizadorExibirBannerAdmob_Tick
	temporizadorExibirBannerAdmob.Enabled = False
	temporizadorOcultarBannerAdmob.Enabled = True
	bnnAdMob.exibirBanner( baseMod.alturaTela - baseMod.alturaBannerAdmob,0dip)
End Sub

Sub temporizadorOcultarBannerAdmob_Tick
	temporizadorExibirBannerAdmob.Enabled = True
	temporizadorOcultarBannerAdmob.Enabled = False
	bnnAdMob.ocultarBanner(0dip,baseMod.alturaTela - baseMod.alturaBannerAdmob) 'É invertido mesmo
End Sub

Sub tratarRetornoCliqueBanner
	bnnAdMob.ocultarBanner(0dip,baseMod.alturaTela - baseMod.alturaBannerAdmob) 'É invertido mesmo
End Sub